#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "macro.h"
#include "const.h"

float *farray1();
void free_farray1();
FILE *getfp();
void fill_hh();
float spl();
float **farray2();
void free_farray2();
void harmogrid();
float *assolegendre();
float factor();
void rotmatrix();

/* Global variables */
float  Xx0,Yy0,Xlen,Ylen,Dx,Dy,Contour[100];
int    Row, Col;
float Theta,Phi,Az;
FILE *gridf;

void griddefault(flag)
int flag;
{
char  txt[MAXSTR],dum[MAXSTR],c;
int   i,j,index;
FILE *fp;

  if(flag){
           
    if((fp=fopen("lu_01","r"))==0)
      stop("Cannot open default file");
/*
 * read default settings
 */    
    while(fgets(txt,MAXSTR,fp)){
        if(!strncmp(txt,"$Map_Coordinate",15)){
               getfloat(fp,dum,Xx0);
               getfloat(fp,dum,Yy0);
               getfloat(fp,dum,Xlen);
               getfloat(fp,dum,Ylen);
         }else if(!strncmp(txt,"$Grid",5)){
               getint(fp,dum,Row);
               getint(fp,dum,Col);
         }else if(!strncmp(txt,"$Maprotation",12)){
               getfloat(fp,dum,Theta);
               getfloat(fp,dum,Phi);
               getfloat(fp,dum,Az);
         }
     }
    fclose(fp);
  
    Dx=Xlen/(float)(Col-1); /* grid increment in longitudinal  and  */
    Dy=Ylen/(float)(Row-1); /* in latitudinal directions            */
    Theta=(90.-Theta)*CONV;
    Phi*=CONV; while(Phi<0.0) Phi+=2.*PI; while(Phi>2.*PI) Phi-=2.*PI;
    Az*=CONV;
 } 
}

/******************************************/
void gridanis()
/* same as gridA1d_q3, read the g3d header format of acal_anis_auto */
/* requires same radial parameterization in all blocks */
{
char disc[4][6],string[40],ifset;
float *coef;
FILE *fp,*A1pf;
int maxs[NPAR],nkw[NPAR],nku[NPAR],nkl[NPAR],nknots,wfcn,nblocks;
int ndis,rmax,jump,hmax[NPAR],mdim,vjump,i,p,nn,k,ipar,jump0;
float mindep,maxdep,fac,x,r,*mdl,*knot;
char block[NPAR];

  fp=getfp("r");
  fscanf(fp,"%d",&nblocks);
  for(k=0;k<nblocks;k++){
    fscanf(fp,"%d",&maxs[k]);
    fscanf(fp,"%d",&nkw[k]);
    fscanf(fp,"%d",&nku[k]);
    fscanf(fp,"%d",&nkl[k]);
    fscanf(fp,"%d",&wfcn);
    fscanf(fp,"%s",&block[k]);
    if(maxs[k]>MAXS) stop("gridanis: maxs too large");
    if(wfcn==0)printf("Warning; may be Legendre parameterization\n");
  }
  fscanf(fp,"%d",&ndis);

   mindep=RADIUS;
   maxdep=RADIUS-RCMB;
 
  if((A1pf=fopen("lu_A1.par","r"))==0)stop("Cannot open A1.par file");

  disc[0][0]=disc[1][0]=disc[2][0]=disc[3][0]='\0'; 
  if(ndis)
  { printf(";  Discontinuities:");
    for(i=0;i<ndis;i++)
    { fscanf(fp,"%s",disc[i]);
      printf(" %s",disc[i]);
    }
  }
  printf("\n");
  fscanf(A1pf,"%d",&nknots);
  if(nknots!=nkw[0]+nku[0]+nkl[0]+3)stop("dimension error in knots"); 
  printf(" Depth range: [%4d %4d] km", (int)mindep,(int)maxdep);
  knot=farray1(0,nknots-1);
  printf(" \n knot position at depth km :");
  for(i=0;i<nknots;i++)
  { fscanf(A1pf,"%f",&knot[i]);   
    printf("%.2f ",6371-knot[i]);
    }   
  printf(" \n");
  fclose(A1pf);

  printf("Enter parameter to plot:");
  scanf("%s",string);

  mdim=0;
  for(k=0;k<nblocks;k++) 
  {  hmax[k]=(maxs[k]+1)*(maxs[k]+1);
    mdim+=hmax[k]*(nknots);
    if(block[k]==string[0]) ipar=k;
  }
  vjump=mdim;
  mdim+=hmax[0]*ndis;
  mdl=farray1(0,mdim-1);
  for(i=0;i<mdim;i++) fscanf(fp,"%g",&mdl[i]);
  fclose(fp);
  
  jump0=0; 
  for(k=0;k<ipar;k++) 
  {  hmax[k]=(maxs[k]+1)*(maxs[k]+1);
     jump0+=hmax[k]*(nknots);
  }
  
  coef=farray1(0,hmax[ipar]-1);
  
  ifset='y';

 do {
    printf(" Specify a depth,");
    if(ndis){
      printf(" or ");
      for(i=0;i<ndis;i++) printf("'%c' ",disc[i][0]);
      printf(" for discontinuity,");
    }
    printf(" or 'q' to quit:");
    scanf("%s",string);
    if(string[0]=='q')break;
    
    if(string[0]=='s') for(i=0;i<hmax[0];i++) coef[i]=mdl[vjump+i]*6368.0;
    else if(string[0]=='m'){ 	/* Moho */
      if(disc[0][0]=='m') jump=0;
      else if(disc[1][0]=='m') jump=hmax[0];
      else if(disc[2][0]=='m') jump=2*hmax[0];
      else stop("gridA1d: error in getting moho");
      for(i=0;i<hmax[0];i++) coef[i]=mdl[vjump+jump+i]*RMOHO;
    }
    else if(string[0]=='d')
    { if(disc[0][0]=='d') jump=0;
      else if(disc[1][0]=='d') jump=hmax[0];
      else if(disc[2][0]=='d') jump=2*hmax[0];
      else stop("gridA1d: error in getting d670");
      for(i=0;i<hmax[0];i++) coef[i]=mdl[vjump+jump+i]*R670;
    }
    else if(string[0]=='c')
      for(i=0;i<hmax[0];i++) coef[i]=mdl[vjump+hmax[0]*(ndis-1)+i]*RCMB;
    /*else if(string[0]=='k'){	
      if(disc[0][0]=='k') jump=0;
      else if(disc[1][0]=='k') jump=hmax[0];
      else if(disc[2][0]=='k') jump=2*hmax[0];
      else stop("grids3d: error in getting Konrad");
      for(i=0;i<hmax[0];i++)
        coef[i]=mdl[vjump+jump+i]*RKONRAD;
    } */
    else if(string[0]>='1' && string[0]<='9'){
      sscanf(string,"%f",&r);
      r=RADIUS-r;
      
      jump=0;
            
      for(i=0;i<hmax[ipar];i++) coef[i]=0.;
      for(p=0;p<nknots;p++){
        fac=100*spl(p,nknots,knot,r);  /* percentage */
        for(i=0;i<hmax[ipar];i++) coef[i]+=fac*mdl[jump0+jump+i+p*hmax[ipar]];	
      }
    }
    if(string[0]!='q')string[0]='\0';
    harmogrid(maxs[ipar],coef,"X^",ifset);
    ifset='n';
  } while(string[0]!='q');

  free_farray1(mdl,0);
  free_farray1(coef,0);
}


/******************************************/
/*memory functions*/

float *farray1(n11,n12)
int n11,n12;
{
float *m;
	m=(float *)malloc( U (n12-n11+1)*sizeof(float) );
	if(!m) stop("allocation error in farray1");
	return(m-n11);
}
void free_farray1(a,n11)
float *a;
int n11;
{
	free(&a[n11]);
}

float **farray2(n11,n12,n21,n22)
int n11,n12,n21,n22;
{
int i;
float **m;
	m=(float **)malloc( U (n12-n11+1)*sizeof(float*) );
	if(!m) stop("allocation error 1 in farray2");
	m-=n11;
	
	for(i=n11;i<=n12;i++)
	{ m[i]=(float *)malloc( U (n22-n21+1)*sizeof(float) );
	  if(!m[i]) stop("allocation error 2 in farray2");
	  m[i]-=n21;
	}
	return(m);
}
void free_farray2(a,n11,n12,n21)
float **a;
int n11,n12,n21;
{
int i;	
    for(i=n11;i<=n12;i++) {
	/* Free second dimension array (which contains data). */
        free(&(a[i][n21]));
    }
    /* Free first dimension array which pointed to second dimension. */
    free(&(a[n11]));
}

/******************************************/
/*io functions*/

FILE *getfp(fptype)
char *fptype;
{
char string[60];
FILE *fp;

  do
  { printf("\nFile name: ");
    scanf("%s%*c",string);
    fp=fopen(string,fptype);
    if(fp==NULL) printf("File %s cannot be opened, please try again.",string);
  } while(fp==NULL);
  
  return(fp);
}

/******************************************/
/*spline functions*/
float spl(ord,nknots,knot,xi)
int ord,nknots;
float *knot,xi;
/* ord: number of rho(x)
   nknots : # of knkots = Nx+1 (Nx=index of highest spline)
   xi: point of interest
   splines defined as :
   f_i(x) = a_i(x-x_i)^3 + b_i(x-x_i)^2 + c_i(x-x_i) + d_i
*/
{
int ii,Nx;
float *hh,rho_x;
float coefa,coefb,coefc,coefd;
  
  Nx=nknots-1;
  /* Compute vector hh of spacings */
  hh=farray1(0,Nx-1);
  fill_hh(hh,knot,Nx);
  
  /* Consistency checks */
  if((xi-(float)TOL)>knot[Nx]){
    printf("xi=%g / knot[%d]=%g",xi,Nx,knot[Nx]);
    stop("spl: xi>knot[Nx]");
  }
  else if((xi+(float)TOL)<knot[0]){
    printf("xi=%g / knot[0]=%g",xi,knot[0]);
    stop("spl: xi<knot[0]");
  }
  else if(ord>Nx)
    stop("spl: order > Nx");
  
  if(ord==0){	/* LHS */
  float denom;
    denom=3.*hh[ord]*hh[ord]+3.*hh[ord]*hh[ord+1]+hh[ord+1]*hh[ord+1];
    if(xi>=knot[ord]&&xi<=knot[ord+1]){			/* x0<=x<=x1 */
      coefa=4./(hh[ord]*(hh[ord]+hh[ord+1])*denom);
      coefb=0.0;
      coefc=-12/denom;
      coefd=4*(2*hh[ord]+hh[ord+1])/denom;
      
      rho_x=coefa*(xi-knot[ord])*(xi-knot[ord])*(xi-knot[ord]);
      rho_x+=coefb*(xi-knot[ord])*(xi-knot[ord]);
      rho_x+=coefc*(xi-knot[ord]);
      rho_x+=coefd;
    }
    else if(xi>knot[ord+1]&xi<=knot[ord+2]){		/* x1<=x<=x2 */
      coefa=-4./(hh[ord+1]*(hh[ord]+hh[ord+1])*denom);
      coefb=12/((hh[ord]+hh[ord+1])*denom);
      coefc=-12.*hh[ord+1]/((hh[ord]+hh[ord+1])*denom);
      coefd=4.*hh[ord+1]*hh[ord+1]/((hh[ord]+hh[ord+1])*denom);
      
      rho_x=coefa*(xi-knot[ord+1])*(xi-knot[ord+1])*(xi-knot[ord+1]);
      rho_x+=coefb*(xi-knot[ord+1])*(xi-knot[ord+1]);
      rho_x+=coefc*(xi-knot[ord+1]);
      rho_x+=coefd;
    }
    else						/* x>x2 */
      rho_x=0.0; 
  }
  
  else if(ord==1){	/* LHS+1 */
  float denom,denomsum,dd;
    denom=(3.*hh[ord-1]*hh[ord-1]+4.*hh[ord-1]*hh[ord]+hh[ord]*hh[ord]+
           2.*hh[ord-1]*hh[ord+1]+hh[ord]*hh[ord+1]);
    denomsum=hh[ord-1]+hh[ord]+hh[ord+1];
    dd=denomsum*denom;
    if(xi>=knot[ord-1]&&xi<=knot[ord]){			/* x0<=x<=x1 */
      coefa=-4.*(3.*hh[ord-1]+2.*hh[ord]+hh[ord+1])/
      	    (hh[ord-1]*(hh[ord-1]+hh[ord])*dd);
      coefb=0.;
      coefc=12./denom;
      coefd=0.;
      
      rho_x =coefa*(xi-knot[ord-1])*(xi-knot[ord-1])*(xi-knot[ord-1]);
      rho_x+=coefb*(xi-knot[ord-1])*(xi-knot[ord-1]);
      rho_x+=coefc*(xi-knot[ord-1]);
      rho_x+=coefd;
    }
    
    else if(xi>=knot[ord]&&xi<=knot[ord+1]){			/* x1<=x<=x2 */
      coefa=4.*(2.*hh[ord-1]*hh[ord-1]+6.*hh[ord-1]*hh[ord]+3.*hh[ord]*hh[ord]+3.*hh[ord-1]*hh[ord+1]+
            3.*hh[ord]*hh[ord+1]+hh[ord+1]*hh[ord+1])/
            (hh[ord]*(hh[ord-1]+hh[ord])*(hh[ord]+hh[ord+1])*dd);
      coefb=-12.*(3.*hh[ord-1]+2.*hh[ord]+hh[ord+1])/
      	    ((hh[ord-1]+hh[ord])*dd);
      coefc=12.*(-2.*hh[ord-1]*hh[ord-1]+hh[ord]*hh[ord]+hh[ord]*hh[ord+1])/
      	    ((hh[ord-1]+hh[ord])*dd);
      coefd=4.*hh[ord-1]*(4.*hh[ord-1]*hh[ord]+3.*hh[ord]*hh[ord]+2.*hh[ord-1]*hh[ord+1]+3.*hh[ord]*hh[ord+1])/
      	    ((hh[ord-1]+hh[ord])*dd);
      	    
      rho_x=coefa*(xi-knot[ord])*(xi-knot[ord])*(xi-knot[ord]);
      rho_x+=coefb*(xi-knot[ord])*(xi-knot[ord]);
      rho_x+=coefc*(xi-knot[ord]);
      rho_x+=coefd;
    }
    
    else if(xi>=knot[ord+1]&&xi<=knot[ord+2]){			/* x2<=x<=x3 */
      dd*=(hh[ord]+hh[ord+1]);
      coefa=-4.*(2.*hh[ord-1]+hh[ord])/(hh[ord+1]*dd);
      coefb=12.*(2.*hh[ord-1]+hh[ord])/dd;
      coefc=-12.*(2.*hh[ord-1]+hh[ord])*hh[ord+1]/dd;
      coefd=4.*(2.*hh[ord-1]+hh[ord])*hh[ord+1]*hh[ord+1]/dd;
      
      rho_x=coefa*(xi-knot[ord+1])*(xi-knot[ord+1])*(xi-knot[ord+1]);
      rho_x+=coefb*(xi-knot[ord+1])*(xi-knot[ord+1]);
      rho_x+=coefc*(xi-knot[ord+1]);
      rho_x+=coefd;
    }
    else						/* x>x3 */
      rho_x=0.0; 
  }
  
  else if(ord==Nx-1){		/* RHS-1 */
  float denom,denomsum,dd;
    denom=hh[ord-2]*hh[ord-1]+hh[ord-1]*hh[ord-1]+2.*hh[ord-2]*hh[ord]+4.*hh[ord-1]*hh[ord]+3.*hh[ord]*hh[ord];
    denomsum=hh[ord-2]+hh[ord-1]+hh[ord];
    dd=denomsum*denom;
    if(xi>=knot[ord-2]&&xi<=knot[ord-1]){	/* x0<=x<=x1 */
      coefa=4.*(hh[ord-1]+2.*hh[ord])/(hh[ord-2]*(hh[ord-2]+hh[ord-1])*dd);
      coefb=coefc=coefd=0.0;
      
      rho_x =coefa*(xi-knot[ord-2])*(xi-knot[ord-2])*(xi-knot[ord-2]);
      rho_x+=coefb*(xi-knot[ord-2])*(xi-knot[ord-2]);
      rho_x+=coefc*(xi-knot[ord-2]);
      rho_x+=coefd;
    }
    
    else if(xi>=knot[ord-1]&&xi<=knot[ord]){	/* x1<=x<=x2 */
      coefa=-4.*(hh[ord-2]*hh[ord-2]+3.*hh[ord-2]*hh[ord-1]+3.*hh[ord-1]*hh[ord-1]+3.*hh[ord-2]*hh[ord]+
             6.*hh[ord-1]*hh[ord]+2.*hh[ord]*hh[ord])/
             (hh[ord-1]*(hh[ord-2]+hh[ord-1])*(hh[ord-1]+hh[ord])*dd);
      coefb=12.*(hh[ord-1]+2.*hh[ord])/((hh[ord-2]+hh[ord-1])*dd);
      coefc=12.*hh[ord-2]*(hh[ord-1]+2.*hh[ord])/((hh[ord-2]+hh[ord-1])*dd);
      coefd=4.*hh[ord-2]*hh[ord-2]*(hh[ord-1]+2.*hh[ord])/((hh[ord-2]+hh[ord-1])*dd);
      
      rho_x =coefa*(xi-knot[ord-1])*(xi-knot[ord-1])*(xi-knot[ord-1]);
      rho_x+=coefb*(xi-knot[ord-1])*(xi-knot[ord-1]);
      rho_x+=coefc*(xi-knot[ord-1]);
      rho_x+=coefd;
    }
    
    else if(xi>=knot[ord]&&xi<=knot[ord+1]){	/* x2<=x<=x3 */
      dd*=(hh[ord-1]+hh[ord]);
      coefa=4.*(hh[ord-2]+2.*hh[ord-1]+3.*hh[ord])/(hh[ord]*dd);
      coefb=-12.*(hh[ord-2]+2.*hh[ord-1]+3.*hh[ord])/dd;
      coefc=12.*(-hh[ord-2]*hh[ord-1]-hh[ord-1]*hh[ord-1]+2.*hh[ord]*hh[ord])/dd;
      coefd=4.*hh[ord]*(3.*hh[ord-2]*hh[ord-1]+3.*hh[ord-1]*hh[ord-1]+2.*hh[ord-2]*hh[ord]+4.*hh[ord-1]*hh[ord])/dd;
      
      rho_x=coefa*(xi-knot[ord])*(xi-knot[ord])*(xi-knot[ord]);
      rho_x+=coefb*(xi-knot[ord])*(xi-knot[ord]);
      rho_x+=coefc*(xi-knot[ord]);
      rho_x+=coefd;
    }
    else						/* x>x4 */
      rho_x=0.0;
  }
  
  else if(ord==Nx){		/* RHS */
  float denom;
    denom=(hh[ord-2]+hh[ord-1])*(hh[ord-2]*hh[ord-2]+3.*hh[ord-2]*hh[ord-1]+3.*hh[ord-1]*hh[ord-1]);
    if(xi>=knot[ord-2]&&xi<=knot[ord-1]){	/* x0<=x<=x1 */
      coefa=4./(hh[ord-2]*denom);
      coefb=coefc=coefd=0.0;
      
      rho_x =coefa*(xi-knot[ord-2])*(xi-knot[ord-2])*(xi-knot[ord-2]);
      rho_x+=coefb*(xi-knot[ord-2])*(xi-knot[ord-2]);
      rho_x+=coefc*(xi-knot[ord-2]);
      rho_x+=coefd;
    }
    
    else if(xi>=knot[ord-1]&&xi<=knot[ord]){	/* x1<=x<=x2 */
      coefa=-4./(hh[ord-1]*denom);
      coefb=12/denom;
      coefc=12*hh[ord-2]/denom;
      coefd=4.*hh[ord-2]*hh[ord-2]/denom;
      
      rho_x =coefa*(xi-knot[ord-1])*(xi-knot[ord-1])*(xi-knot[ord-1]);
      rho_x+=coefb*(xi-knot[ord-1])*(xi-knot[ord-1]);
      rho_x+=coefc*(xi-knot[ord-1]);
      rho_x+=coefd;
    }
    
    else						/* x>x2 */
      rho_x=0.0;
  }
  
  else{			/* Away from borders */
  float denom1,denom2,denom;
    denom1=hh[ord-2]+hh[ord-1]+hh[ord]+hh[ord+1];
    if(xi>=knot[ord-2]&&xi<=knot[ord-1]){	/* x0<=x<=x1 */
      coefa=4./(hh[ord-2]*(hh[ord-2]+hh[ord-1])*(hh[ord-2]+hh[ord-1]+hh[ord])*denom1);
      coefb=coefc=coefd=0.;
      
      rho_x =coefa*(xi-knot[ord-2])*(xi-knot[ord-2])*(xi-knot[ord-2]);
      rho_x+=coefb*(xi-knot[ord-2])*(xi-knot[ord-2]);
      rho_x+=coefc*(xi-knot[ord-2]);
      rho_x+=coefd;
    }
    else if(xi>=knot[ord-1]&&xi<=knot[ord]){	/* x1<=x<=x2 */
      denom2=(hh[ord-2]+hh[ord-1])*(hh[ord-2]+hh[ord-1]+hh[ord]);
      denom=denom1*denom2;
      
      coefa=-4.*(hh[ord-2]*hh[ord-2]+3.*hh[ord-2]*hh[ord-1]+3.*hh[ord-1]*hh[ord-1]+2.*hh[ord-2]*hh[ord]+
      4.*hh[ord-1]*hh[ord]+hh[ord]*hh[ord]+hh[ord-2]*hh[ord+1]+2.*hh[ord-1]*hh[ord+1]+hh[ord]*hh[ord+1])/
      (hh[ord-1]*(hh[ord-1]+hh[ord])*(hh[ord-1]+hh[ord]+hh[ord+1])*denom);
      coefb=12./denom;
      coefc=12.*hh[ord-2]/denom;
      coefd=4.*hh[ord-2]*hh[ord-2]/denom;
      
      rho_x =coefa*(xi-knot[ord-1])*(xi-knot[ord-1])*(xi-knot[ord-1]);
      rho_x+=coefb*(xi-knot[ord-1])*(xi-knot[ord-1]);
      rho_x+=coefc*(xi-knot[ord-1]);
      rho_x+=coefd;
    }
    
    else if(xi>=knot[ord]&&xi<=knot[ord+1]){	/* x2<=x<=x3 */
      denom2=(hh[ord-1]+hh[ord])*(hh[ord-2]+hh[ord-1]+hh[ord])*(hh[ord-1]+hh[ord]+hh[ord+1]);
      denom=denom1*denom2;
      
      coefa=4.*(hh[ord-2]*hh[ord-1]+hh[ord-1]*hh[ord-1]+2.*hh[ord-2]*hh[ord]+4.*hh[ord-1]*hh[ord]+3.*hh[ord]*hh[ord]+
      	    hh[ord-2]*hh[ord+1]+2.*hh[ord-1]*hh[ord+1]+3.*hh[ord]*hh[ord+1]+hh[ord+1]*hh[ord+1])/
      	    (hh[ord]*(hh[ord]+hh[ord+1])*denom);
      coefb=-12.*(hh[ord-2]+2.*hh[ord-1]+2.*hh[ord]+hh[ord+1])/denom;
      coefc=12.*(-hh[ord-2]*hh[ord-1]-hh[ord-1]*hh[ord-1]+hh[ord]*hh[ord]+hh[ord]*hh[ord+1])/denom;
      coefd=4.*(2.*hh[ord-2]*hh[ord-1]*hh[ord]+2.*hh[ord-1]*hh[ord-1]*hh[ord]+hh[ord-2]*hh[ord]*hh[ord]+
      	    2.*hh[ord-1]*hh[ord]*hh[ord]+hh[ord-2]*hh[ord-1]*hh[ord+1]+hh[ord-1]*hh[ord-1]*hh[ord+1]+
      	    hh[ord-2]*hh[ord]*hh[ord+1]+2.*hh[ord-1]*hh[ord]*hh[ord+1])/denom;
     
      rho_x=coefa*(xi-knot[ord])*(xi-knot[ord])*(xi-knot[ord]);
      rho_x+=coefb*(xi-knot[ord])*(xi-knot[ord]);
      rho_x+=coefc*(xi-knot[ord]);
      rho_x+=coefd;
    }
             
    else if(xi>=knot[ord+1]&&xi<=knot[ord+2]){	/* x3<=x<=x4 */
      denom2=(hh[ord]+hh[ord+1])*(hh[ord-1]+hh[ord]+hh[ord+1]);
      denom=denom1*denom2;
      
      coefa=-4./(hh[ord+1]*denom);
      coefb=12/denom;
      coefc=-12*hh[ord+1]/denom;
      coefd=4.*hh[ord+1]*hh[ord+1]/denom;
      
      rho_x=coefa*(xi-knot[ord+1])*(xi-knot[ord+1])*(xi-knot[ord+1]);
      rho_x+=coefb*(xi-knot[ord+1])*(xi-knot[ord+1]);
      rho_x+=coefc*(xi-knot[ord+1]);
      rho_x+=coefd;
    }
    
    else						/* x>x4 */
      rho_x=0.0;
  }
  free_farray1(hh,0);
  return(rho_x);
}

void fill_hh(hh,knot,Nx)
float *hh,*knot;
int Nx;
{
int ii;

  for(ii=0;ii<Nx;ii++)
    hh[ii]=knot[ii+1]-knot[ii];
}

/******************************************/
/*spherical harmonics functions*/

void harmogrid(maxs,coef,conven,ifset)
int maxs;
float *coef;   /* spherical harmonic coefficients: a, b
		* f=sum (a*cos(m*phi)+b*sin(m*phi))*P(theta)
                */
char *conven; /*convention of spherical harmonic: P, p, X, X^, P^*/
/* For s3d files, convention must be X^ */
char ifset;   /*'y': set smin,smax,aeo*/
{
float **grid,**cossintphi,**p,*y,fac;
static int smin,smax;
static char aeo;
float theta,phi,sum,gdmx;
int s,t,index,i,j,k,imax;
float cosphi,sinphi,costph,sintph,temp;
char name[NAME];

        if(ifset=='y')
        { printf("\nMax degree of model is %d",maxs);
	  do
	  { printf("\nsmin & smax of grid :");
	    scanf("%d %d%*c",&smin,&smax);
	  } while(smax>maxs);
	
	  do
	  { printf("\nType 'a' to grid  all degrees");
	    printf("\n     'e' to grid even degrees only");
	    printf("\n or  'o' to grid  odd degrees only  :");
	    scanf("%c",&aeo);
	  } while(aeo!='a' && aeo!='e' && aeo!='o');
	}
        maxs=smax;
        
        imax=(maxs+1)*(maxs+1);
	
	for(index=0,s=0;s<smin;s++)
	for(t=0;t<2*s+1;t++)
	  coef[index++]=0.0;
	
	if(aeo!='a')
	for(s=smin;s<=smax;s++)
	{ fac=1.;
	  if( (s%2 && aeo=='e') || (!(s%2) && aeo=='o') ) fac=0.;
	  for(t=0;t<2*s+1;t++)
	    coef[index++]*=fac;
	}

	p=farray2(0,Row-1,0,imax-1);
	for(i=0;i<Row;i++)
	{ theta=CONV*Dy*(float)i;
	  if(theta<0.0) theta=0.0;
	  if(theta>PI) theta=PI;
	  for(index=-1,s=0;s<=maxs;s++)
	  { y=assolegendre(theta,s,conven);
	    for(t=0;t<=s;t++)
	    { p[i][++index]=y[t];
	      if(t) p[i][++index]=y[t];
	    }
	  }
	}
	
	cossintphi=farray2(0,Col-1,0,imax-1);
	for(j=0;j<Col;j++)
	{ phi=CONV*((float)j*Dx);
	  cosphi=(float)cos((double)phi);
	  sinphi=(float)sin((double)phi);
	  for(index=-1,s=0;s<=maxs;s++)
	  for(costph=1.0,sintph=0.0,t=0;t<=s;t++)
	  { cossintphi[j][++index]=costph;
	    if(t) cossintphi[j][++index]=sintph;
	    temp=costph*cosphi-sintph*sinphi;
	    sintph=sintph*cosphi+costph*sinphi;
	    costph=temp;
	  }
	}
	
	grid=farray2(0,Row-1,0,Col-1);
	for(i=0;i<Row;i++)
	for(j=0;j<Col;j++)
	{ for(sum=0.0,k=0;k<imax;k++)
	    sum+=coef[k]*cossintphi[j][k]*p[i][k];
	  grid[i][j]=sum;
	}
	
	printf("Enter name of output file > ");
	scanf("%s",name);
	if((gridf=fopen(name,"w"))==0)stop("Cannot open output file");

	gdmx=0.;

	for(i=0;i<Row;i++) {
          theta=Dy*(float)i;
	  for(j=0;j<Col;j++) {
	    phi=((float)j*Dx);
	    if(phi!=360.){
	      fprintf(gridf,"%.1f\t%.1f\t%.5f\n",phi,90-theta,grid[i][j]);
	      if(fabs(grid[i][j])>gdmx) gdmx=fabs(grid[i][j]);
            }
	  }
	}

	printf("\nthe maximum grid data is %.5f\n\n",gdmx);
	fclose(gridf);
}

float *assolegendre(theta,l,conventn)
float theta;
int l;
char *conventn; /*available convention: d(l,m), 0<=m<=l;
                 *                      p(l,m), 0<=m<=l;
                 *                      f(l)           ;
                 *                      X(l,m), 0<=m<=l;
                 *                      X^(l,m),0<=m<=l;
                 *                      P(l,m), 0<=m<=l;
                 */
{
static int current_dim=0;
static float *x,**d;
static int mem;
int dim,m;
void *test;
float fac,sign;

	dim=2*l+1;
	if(dim>current_dim)
	{ if(current_dim)
	  { free(x);
	    free_farray2(d,0,0,mem);
	  }
	  if( (x=(float *)malloc(sizeof(float)*dim)) ==NULL)
	    stop("assolegendre: malloc failed 1");
	  d=farray2(0,0,-l,l);
	  current_dim=dim;
	  mem=-l;
	}
	
	rotmatrix(0,l,theta,d);
	
	if(!strcmp(conventn,"d"))
	{ for(m=0;m<=l;m++) x[m]=d[0][m]; 
	}
	else if(!strcmp(conventn,"p"))
	{ for(sign=1.0,m=0;m<=l;sign=-sign,m++)
	  { fac=(float)(2*l+1);
	    if(m) fac*=2.0;
	    fac=sign*(float) sqrt( (double)fac );
	    x[m]=fac*d[0][m];
	  }
	}
	else if(!strcmp(conventn,"f"))
	{ fac=0.5*(float)(2*l+1);
	  fac=(float) sqrt( (double)fac );
	  *x=fac*d[0][0];
	}
	else if(!strcmp(conventn,"X"))
	{ for(m=0;m<=l;m++)
	  { fac=((float)(2*l+1))/(4.*PI);
	    fac=(float)sqrt((double)fac);
	    x[m]=fac*d[0][m];
	  }
	}
	else if(!strcmp(conventn,"X^"))
	{ for(m=0;m<=l;m++)
	  { fac=((float)(2*l+1))/(8.*PI);
	    if(m) fac*=2.0;
	    fac=(float)sqrt((double)fac);
	    x[m]=fac*d[0][m];
	  }
	}
	else if(!strcmp(conventn,"P"))
	{ for(sign=1.0,m=0;m<=l;sign=-sign,m++)
	  { fac=factor(l,m);
	    fac=sign*(float)sqrt((double)fac);
	    x[m]=fac*d[0][m];
	  }
	}
	else stop("assolegendre: illegal convention");
	
	return(x);
}

float factor(l,m) /* (l+m)!/(l-m)! | m>=0 */
int l,m;
{
float f;
int i;  if(m<0 || m>l) stop("assolegendre_factor: illegal m");
	f=1.0;
	for(i=m;i>=-m+1;i--) f*=(float)(l+i);
	return(f);
}

void rotmatrix(Nmax,l,beta,d)
int Nmax,l;
float beta;
float **d;   /* 2*Nmax+1 by 2*l+1  matrix */
{
int swtch,change;
int N,m;
float shbt,chbt,sbt,cbt,logf,logs;
float fN,t1,sign,part,fac,temp;
int mult,i;
	
	
	if(Nmax>l) stop("rotmatrix: N larger than l");
	if(l==0) 
	{ **d=1.0;
	  return;
	}
	
	change=0;
	if(beta<0)
	{ change=1;
	   beta=-beta;
	}
	
	swtch=1;
	if(beta>PI/2.)
	{ beta=PI-beta;
	  swtch=-1;
	}
	
	if(beta<1.e-04 && beta>-1.e-04) beta=0.0;
	if(beta<0.0) stop("rotmatrix: illegal beta");
/*-------------------------------*/
	
	if(beta==0.0)
	{ for(N=-Nmax;N<=Nmax;N++)
	  { sign=1.0;
	    for(m=-l;m<=l;m++)
	    { d[N][m]=0.0;
	      if((N*swtch)==m) d[N][m]=sign;
	      sign*=swtch;
	    }
	  }
	  return ;
	}
/*-------------------------------*/
        for(N=-Nmax;N<=Nmax;N++)	   /*zero l.h.s. of matrix*/
	for(m=-l;m<=0;m++) d[N][m]=0.0;
	    
 /*set up parameters*/
        shbt=sin( (D)(0.5*beta) );
        chbt=cos( (D)(0.5*beta) );
        sbt=2.0*shbt*chbt;
        cbt=2.0*chbt*chbt-1.0;
        logf= log10( (D)(chbt/shbt) );
        logs= log10( (D)shbt );
        
/*iterate from last column using 1. as starting value*/
        for(N=-Nmax;N<=Nmax;N++)
        { fN=(F) N;
          d[N][l]=1.0;
          for(m=l-1;m>=abs(N);m--)
          { if(m+1==l) t1=0.0;
            else t1=-d[N][m+2]* sqrt( (D)((l+2+m)*(l-1-m)) );
            d[N][m]=t1-(2.0/sbt)*(cbt*(F)(m+1)-fN)*d[N][m+1];
            d[N][m]/= sqrt( (D)((l+m+1)*(l-m)) );
            
            if( fabs((D)d[N][m])>=BIG && m!=abs(N) )
            { d[N][-m]=LOGBIG;
              d[N][m]/=BIG;
              d[N][m+1]/=BIG;
            }
          }
        }
        
/*set up normalization for last column;
 *using the first column as temp working space to store the logrithms.
 */
         t1=logs*(F)(2*l);
         for(N=-l+1;N<=-Nmax;N++)
           t1+=logf+0.5* log10( (D)(l+1-N)/(D)(N+l) );
         d[-Nmax][-l]=t1;
         for(N=-Nmax+1;N<=Nmax;N++)
           d[N][-l]=d[N-1][-l]+logf+0.5* log10( (D)(l-N+1)/(D)(l+N) );                  
/*renormalize rows*/
        sign=1.0;
        if( (l-Nmax)%2 ) sign=-1.0;
        for(N=-Nmax;N<=Nmax;sign=-sign,N++)
        { part=d[N][-l];
          mult=1;
          while(fabs((D) part)>=LOGBIG)
          { mult*=2;
            part*=0.5;
          }
          fac= pow(10.0, (D)part);
          for(m=l;m>=abs(N);m--)
          { if(d[N][-m+1]!=0.0 && -m+1<-abs(N) )
            { part=part*(F)(mult)+d[N][-m+1];
              mult=1;
              while(fabs((D) part)>=LOGBIG)
              { mult*=2;
                part*=0.5;
              }
              fac= pow(10.0, (D) part);
            }
            for(i=0;i<mult;i++)
            { d[N][m]*=fac;
              if( fabs((D)d[N][m])<=SMALL ) break;
            }
            d[N][m]*=sign;
          }
        }
/* correction for beta<0, using d[N][m](-b)=(-1)**(N+m)*d[N][m](b) */

	if(change)
	{ for(N=-Nmax;N<=Nmax;N++)
	  { sign=1.0; if((l+N)%2) sign=-1.0;
	    for(m=l;m>=abs(N);m--,sign=-sign) d[N][m]*=sign;
	  }
	}

/*fill rest of matrix*/
	if(swtch<0)
	{ sign=1.0;
	  if( (l-Nmax)%2 ) sign=-1.0;
	  for(N=-Nmax;N<=Nmax;sign=-sign,N++)
	  for(m=-l;m<=-abs(N);m++)
	    d[N][m]=sign*d[N][-m];
	    
	  for(N=-Nmax;N<=Nmax;N++)
	  for(sign=1.0,m=abs(N);m<=l;sign=-sign,m++)
	  { d[N][m]=sign*d[-N][-m];
	    if(m<=Nmax)
	    { d[-m][-N]=d[N][m];
	      d[m][N]=d[-N][-m];
	    }
	  }
	}
	
	else
	{ for(N=-Nmax;N<=Nmax;N++)
	  for(sign=1.0,m=-abs(N);m>=-l;sign=-sign,m--)
	  { d[N][m]=sign*d[-N][-m];
	    if(abs(m)<=Nmax)
	    { d[-m][-N]=d[N][m];
	      d[m][N]=d[-N][-m];
	    }
	  }
	}
}


